
#include <stdio.h>
#include <string.h>
#include <malloc.h>
#include <time.h>
#include <dlna_stringtable.h>

#define STRING_TABLE_FILE_NAME "/etc/config/PanaDLNAString.bin"

static CustomizeTableStruct* psCustomStringTable = NULL;
int lEnablePanaString = 1;
int GetEnablePanaString(void)
{
    return lEnablePanaString;
}    

void SetEnablePanaString(int lInputValue)
{
    lEnablePanaString = lInputValue;
}    
char* GetDLNACustomizedTableString(EnumCustomizeTableIndex eTableIndex)
{
    if(psCustomStringTable == NULL)  {
        printf("ERRROR! Should init string table at first\n");
        return NULL;
    }    
        
    return  psCustomStringTable[eTableIndex].bDescription; 
}

int InitStringTableData(void)
{
  FILE* psFileID = NULL;
  
  psFileID = fopen(STRING_TABLE_FILE_NAME,"r");
  
  if(psFileID == NULL) {
      printf("ERROR!! Can't open file\n");
      return -1;
  }    
  psCustomStringTable = malloc(sizeof(CustomizeTableStruct)*CUSTOMIZE_TABLE_ITEM_MAX_NUMBER);
  fread(psCustomStringTable,1,sizeof(CustomizeTableStruct)*CUSTOMIZE_TABLE_ITEM_MAX_NUMBER,psFileID);


  fclose(psFileID);
  return 0;
}

int DeinitStringTableData(void)
{
  if(psCustomStringTable != NULL)  {
      free(psCustomStringTable);
      psCustomStringTable = NULL;
  }  
  
  return 0;
}

