
#ifndef __DLNA_STRINGTABLE_H__
#define __DLNA_STRINGTABLE_H__


#define CUSTOMIZE_TABLE_ITEM_MAX_NUMBER 30
#define CUSTOMIZE_TABLE_DESCRIPTION_MAX_LEN 64
typedef struct _CustomizeTableStruct_
{
  int   lType;
  char  bDescription[CUSTOMIZE_TABLE_DESCRIPTION_MAX_LEN];        
} CustomizeTableStruct;

typedef enum _EnumCustomizeTableStringType_
{
    PANA_STRING_TYPE_UNKWON          = 0x000,
    PANA_STRING_TYPE_BROWSE_GENERAL  = 0x10,
    PANA_STRING_TYPE_BROWSE_REQUEST  = 0x11,
    PANA_STRING_TYPE_BROWSE_RESPONSE = 0x12,
    PANA_STRING_TYPE_GET_CONTENT     = 0x20,
}EnumCustomizeTableStringType;
typedef enum _EnumCustomizeTableIndex_
{
    PANA_TABLE_INDEX_XML_NAME_SPACEDEF              =0 ,
    PANA_TABLE_INDEX_BROWSE_PROTOCOLINFO            =1 ,
    PANA_TABLE_INDEX_BROWSE_TAG_PANA_SIZE           =2 ,
    PANA_TABLE_INDEX_BROWSE_SIZE_ORG                =3 ,
    PANA_TABLE_INDEX_BROWSE_SIZE_TN                 =4 ,
    PANA_TABLE_INDEX_BROWSE_SIZE_LRG                =5 ,
    PANA_TABLE_INDEX_BROWSE_SIZE_MPOJPG             =6 ,
    PANA_TABLE_INDEX_BROWSE_SIZE_MPO                =7 ,
    PANA_TABLE_INDEX_BROWSE_SIZE_RAWJPG             =8 ,
    PANA_TABLE_INDEX_BROWSE_SIZE_RAW                =9 ,
    PANA_TABLE_INDEX_BROWSE_TAG_GROUPTYPE           =10,
    PANA_TABLE_INDEX_BROWSE_GROUPTYPE               =11,
    PANA_TABLE_INDEX_BROWSE_GROUPTYPE_STOPMOTION    =12,
    PANA_TABLE_INDEX_BROWSE_GROUPTYPE_TIMELAPSE     =13,
    PANA_TABLE_INDEX_BROWSE_GROUPTYPE_BURST         =14,
    PANA_TABLE_INDEX_BROWSE_TAG_GROUP_TN_URL        =15,
    PANA_TABLE_INDEX_BROWSE_GROUP_TN_URL            =16, 
    PANA_TABLE_INDEX_GET_CONTENT_DATE               =17, 
    PANA_TABLE_INDEX_GET_CONTENT_ROTATE             =18, 
    PANA_TABLE_INDEX_GET_CONTENT_FILE_SIZE          =19,
}EnumCustomizeTableIndex;


extern char *GetDLNACustomizedTableString(EnumCustomizeTableIndex eTableIndex);
extern int InitStringTableData(void);
extern int DeinitStringTableData(void);
extern int GetEnablePanaString(void);
extern void SetEnablePanaString(int lInputValue);
    

#endif
