
#ifndef __HCE_DLNAWIFIINTERFACE_H__
#define __HCE_DLNAWIFIINTERFACE_H__


typedef unsigned long long uint64_t;
typedef unsigned int       uint32_t;
typedef unsigned short     uint16_t;
typedef unsigned char      uint8_t;

#define HCE_WIFI_FILE_FULL_PATH_MAX_LEN                64
#define HCE_WIFI_PB_MSG_FILE_GROUP_INFO_MAX_NUM        15
#define HCE_WIFI_PB_MSG_FILE_GROUP_ENTRY_INFO_MAX_NUM  15


//-------------------------Message type define-------------------------------------------


#define WIRELESSUTILITY_ENUM_DUMMY_VALUE    0xFFFFFFFF  // For size alignment
//---------------------------------------------------------------------------------------------------
//2.Following items are same as Network_LinuxWiFiUISysInterface.h and hce_WiFiUISysInterface.h-
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//---------------------------------------------------------------------------------------------------
/*
#define DLNA_WIFI_MSG_GROUP_WIFI_REQUEST 0x00000
#define DLNA_WIFI_MSG_GROUP_DLNA_REQUEST 0x10000
#define DLNA_WIFI_GROUP_TYPE_GET(x) ((x)|0xF0000)

//Make sure size of enumeration is 4 bytes.

typedef enum  {
  //DLNA_WIFI_MSG_GROUP_WIFI_REQUEST
  //Ex Event or Command to ask DLNA do something.
  DLNA_WIFI_MSGID_SEND_IMAGE_START                              = DLNA_WIFI_MSG_GROUP_WIFI_REQUEST | (0xC000),
  DLNA_WIFI_MSGID_SEND_IMAGE_CANCEL                             = DLNA_WIFI_MSG_GROUP_WIFI_REQUEST | (0xC001),
  DLNA_WIFI_MSGID_SEND_IMAGE_PAUSE                              = DLNA_WIFI_MSG_GROUP_WIFI_REQUEST | (0xC002),
  DLNA_WIFI_MSGID_SEND_IMAGE_RESUME                             = DLNA_WIFI_MSG_GROUP_WIFI_REQUEST | (0xC003),

  
  //DLNA_WIFI_MSG_GROUP_DLNA_REQUEST------------------------------------------------------------------------
  //NOTE: DLNA side send message to WIFI side
  //It should get response.
  DLNA_WIFI_MSGID_PLAYCMD_GET_GROUP_INFROMATION                 = DLNA_WIFI_MSG_GROUP_DLNA_REQUEST | (0xC613),
  DLNA_WIFI_MSGID_PLAYCMD_GET_GROUP_ENTRY_INFROMATION           = DLNA_WIFI_MSG_GROUP_DLNA_REQUEST | (0xC614),
  //------------------------------------------------------------------------
  DLNA_WIFI_MSGID_DUMMY_INDEX                                   = WIRELESSUTILITY_ENUM_DUMMY_VALUE,
} DLNA_WiFi_MsgID_Type;
*/

#define HCE_WIFI_MESSAGE_WIFI_GROUP      0x00000000

typedef enum  {

  //General commands
  HCE_WIFI_MSGID_APP_SCAN                                      = (HCE_WIFI_MESSAGE_WIFI_GROUP + 0x3002),
  HCE_WIFI_MSGID_APP_SELECT                                    = (HCE_WIFI_MESSAGE_WIFI_GROUP + 0x3003),

  //View related commands
  HCE_WIFI_MSGID_SEND_IMAGE_CANCEL                             = (HCE_WIFI_MESSAGE_WIFI_GROUP + 0x3010),
  HCE_WIFI_MSGID_SEND_IMAGE_START                              = (HCE_WIFI_MESSAGE_WIFI_GROUP + 0x3011),
  HCE_WIFI_MSGID_SEND_IMAGE_PAUSE                              = (HCE_WIFI_MESSAGE_WIFI_GROUP + 0x3012),
  HCE_WIFI_MSGID_SEND_IMAGE_RESUME                             = (HCE_WIFI_MESSAGE_WIFI_GROUP + 0x3013),
  HCE_WIFI_MSGID_SEND_IMAGE_FAIL                               = (HCE_WIFI_MESSAGE_WIFI_GROUP + 0xD010),
  HCE_WIFI_MSGID_SEND_IMAGE_DONE                               = (HCE_WIFI_MESSAGE_WIFI_GROUP + 0xD011),
  HCE_WIFI_MSGID_SEND_IMAGE_INFORMATION                        = (HCE_WIFI_MESSAGE_WIFI_GROUP + 0xD020),

  //For PANA PSS CHECK
  HCE_WIFI_MSGID_APP_GET_PSS_CHECK_VALUE                       = (HCE_WIFI_MESSAGE_WIFI_GROUP + 0x3F01),

  //Playback relatedcommands
  HCE_WIFI_MSGID_CGI_PLAYCMD_GET_FILE_INFORMATION              = (HCE_WIFI_MESSAGE_WIFI_GROUP + 0xC609),
  HCE_WIFI_MSGID_CGI_PLAYCMD_DELETE_FILE                       = (HCE_WIFI_MESSAGE_WIFI_GROUP + 0xC60A),
  HCE_WIFI_MSGID_CGI_PLAYCMD_GET_FILE                          = (HCE_WIFI_MESSAGE_WIFI_GROUP + 0xC60B),
  HCE_WIFI_MSGID_CGI_PLAYCMD_NOTIFY_GET_FILE_DONE              = (HCE_WIFI_MESSAGE_WIFI_GROUP + 0xC60C),
  HCE_WIFI_MESID_CGI_PLAYCMD_GET_GROUP_INFROMATION             = (HCE_WIFI_MESSAGE_WIFI_GROUP + 0xC613),
  HCE_WIFI_MESID_CGI_PLAYCMD_GET_GROUP_ENTRY_INFROMATION       = (HCE_WIFI_MESSAGE_WIFI_GROUP + 0xC614),  
  
  HCE_WIFI_MSGID_ENUM_DUMMY                                    =  WIRELESSUTILITY_ENUM_DUMMY_VALUE
}Hce_WiFi_MsgID_Type;
//--------------------------------------------------------------------------------

typedef enum 
{
 DLNA_REMOTE_MSG_RESULT_TYPE_OK            = 0,
 DLNA_REMOTE_MSG_RESULT_TYPE_EXECUTING     = 1,
 DLNA_REMOTE_MSG_RESULT_TYPE_GENERAL_ERROR = -1,
 DLNA_REMOTE_MSG_RESULT_TYPE_DUMMY         = 0xFFFFFFFF,
}DLNARemoteMessageResult;
//-------------------------IPC message structure-------------------------------------------
typedef struct _DLNASendMessageStruct_
{
  Hce_WiFi_MsgID_Type   eMsgId;
  unsigned int          ulReqParaLen;
  void*                 pvReqPara;
}DLNASendMessageStruct;

typedef struct _DLNAResponseMessageStruct_
{
  unsigned int          ulResParaLen;
  void*                 pvResPara;
}DLNAResponseMessageStruct;


typedef struct _DLNAIPCContentReqStruct_
{
   unsigned int     ulReqDataSize;
   unsigned int     ulResponseDataSize;
}DLNAIPCContentReqStruct;

typedef struct _DLNAIPCContentResStruct_
{
   DLNARemoteMessageResult eErrorResult;
}DLNAIPCContentResStruct;

//-------------------------General items-------------------------------------------------------
typedef enum
{
  DLNA_WIFI_FILE_SIZE_TYPE_ORG    = 0x00,
  DLNA_WIFI_FILE_SIZE_TYPE_TN     = 0x01,
  DLNA_WIFI_FILE_SIZE_TYPE_LRG    = 0x02,
  DLNA_WIFI_FILE_SIZE_TYPE_SM     = 0x03,
  DLNA_WIFI_FILE_SIZE_TYPE_DUMMY  = WIRELESSUTILITY_ENUM_DUMMY_VALUE,
} DLNAWiFiFileSizeType;  

typedef enum
{
  DLNA_WIFI_VIDEO_TYPE_1080P_60    = 0x00,
  DLNA_WIFI_VIDEO_TYPE_1080P_50    = 0x01,
  DLNA_WIFI_VIDEO_TYPE_1080P_30    = 0x02,
  DLNA_WIFI_VIDEO_TYPE_1080P_25    = 0x03,
  DLNA_WIFI_VIDEO_TYPE_1080P_24    = 0x04,
  DLNA_WIFI_VIDEO_TYPE_720P_60     = 0x05,
  DLNA_WIFI_VIDEO_TYPE_720P_50     = 0x06,
  DLNA_WIFI_VIDEO_TYPE_720P_30     = 0x07,
  DLNA_WIFI_VIDEO_TYPE_720P_25     = 0x08,
  DLNA_WIFI_VIDEO_TYPE_480P_30     = 0x09,
  DLNA_WIFI_VIDEO_TYPE_480P_25     = 0x0A,
  DLNA_WIFI_VIDEO_TYPE_360P_30     = 0x0B,
  DLNA_WIFI_VIDEO_TYPE_360P_25     = 0x0C,
  DLNA_WIFI_VIDEO_TYPE_DUMMY       = WIRELESSUTILITY_ENUM_DUMMY_VALUE,
} DLNAWiFiVideoType;  

typedef enum
{
  DLNA_WIFI_VIDEO_TYPE_MP4        = 0x00,
  DLNA_WIFI_VIDEO_TYPE_TS         = 0x01,
  DLNA_WIFI_VIDEO_TYPE_UNKNOWN    = 0x02,
} DLNAWiFiVideoFormat;  

//---------------------------------------------------------------------------------------------------

typedef enum
{
  DLNA_WIFI_BROWSE_CONTAINER_TYPE_METADATA   = 0x00,
  DLNA_WIFI_BROWSE_CONTAINER_TYPE_GROUP      = 0x01,
  DLNA_WIFI_BROWSE_CONTAINER_TYPE_DUMMY      = WIRELESSUTILITY_ENUM_DUMMY_VALUE,
} DLNAWiFiBrowseContainerType;

//---------------------------------------------------------------------------------------------------
//2.Following items are same as Network_LinuxWiFiUISysInterface.h and hce_WiFiUISysInterface.h-
//---------------------------------------------------------------------------------------------------
//---------------------------------------------------------------------------------------------------

typedef enum  {
  HCE_WIFI_GROUP_FINFO_FILE_TYPE_ALL         = 0x00,
  HCE_WIFI_GROUP_FINFO_FILE_TYPE_STOP_MOTION = 0x01,
  HCE_WIFI_GROUP_FINFO_FILE_TYPE_BURST       = 0x02,
  HCE_WIFI_GROUP_FINFO_FILE_TYPE_TIMELAPSE   = 0x03,
  HCE_WIFI_GROUP_FINFO_FILE_TYPE_DUMMY       = WIRELESSUTILITY_ENUM_DUMMY_VALUE,
} HceWiFiGroupInfoFileType;

typedef enum  {
  HCE_WIFI_DATABASE_FILE_TYPE_SINGLE_PHOTO    = 0x00,
  HCE_WIFI_DATABASE_FILE_TYPE_VIDEO           = 0x01,
  HCE_WIFI_DATABASE_FILE_TYPE_TIMELAPSE       = 0x02,
  HCE_WIFI_DATABASE_FILE_TYPE_BURST           = 0x03,
  HCE_WIFI_DATABASE_FILE_TYPE_PANORAMA        = 0x04,
  HCE_WIFI_DATABASE_FILE_TYPE_LOOPVIDEO       = 0x05,
  HCE_WIFI_DATABASE_FILE_TYPE_GIF             = 0x06,
  HCE_WIFI_DATABASE_FILE_TYPE_STOP_MOTION     = 0x07,
  HCE_WIFI_DATABASE_FILE_TYPE_DUMMY           = WIRELESSUTILITY_ENUM_DUMMY_VALUE,    
} HceWiFiDatabaseFileType;    

typedef enum  {
  CAMERA_DATABASE_RETRIEVE_BY_INDX    = 0x00,
  CAMERA_DATABASE_RETRIEVE_BY_NAME    = 0x01,
  CAMERA_DATABASE_RETRIEVE_ENUM_DUMMY = WIRELESSUTILITY_ENUM_DUMMY_VALUE
} Hce_WiFi_DataBase_Retrieve_Method;

typedef enum  {
  CAMERA_DATABASE_FILE_SINGLE     = 0x00,
  CAMERA_DATABASE_FILE_VIDEO      = 0x01,
  CAMERA_DATABASE_FILE_TIMELAPSE  = 0x02,
  CAMERA_DATABASE_FILE_BURST      = 0x03,
  CAMERA_DATABASE_FILE_PANORAMA   = 0x04,
  CAMERA_DATABASE_FILE_LOOPVIDEO  = 0x05,
  CAMERA_DATABASE_FILE_GIF        = 0x06,
  CAMERA_DATABASE_FILE_ENUM_DUMMY = WIRELESSUTILITY_ENUM_DUMMY_VALUE
} Hce_WiFi_DataBase_File_Type;

typedef enum  {
  CAMERA_DATABASE_ORIENTATION_DEGREE_0   = 0x01,
  CAMERA_DATABASE_ORIENTATION_DEGREE_90  = 0x06,
  CAMERA_DATABASE_ORIENTATION_DEGREE_180 = 0x03,
  CAMERA_DATABASE_ORIENTATION_DEGREE_270 = 0x08,
  CAMERA_DATABASE_ORIENTATION_ENUM_DUMMY = WIRELESSUTILITY_ENUM_DUMMY_VALUE
} Hce_WiFi_DataBase_Orientation_Type;

typedef enum  {
  CAMERA_DATABASE_ATTRIBUTE_NOT_PROTECTED = 0x00,
  CAMERA_DATABASE_ATTRIBUTE_PROTECTED     = 0x01,
  CAMERA_DATABASE_ATTRIBUTE_ENUM_DUMMY    = WIRELESSUTILITY_ENUM_DUMMY_VALUE
} Hce_WiFi_DataBase_Attribute_Type;

#define HCE_WIFI_CAMERA_DATAPATH_STRLEN 64

typedef struct _Hce_WiFi_Command_DateTime_Struct_  {
  uint16_t Year;
  uint16_t Month;
  uint16_t Day;
  uint16_t Hour;
  uint16_t Minute;
  uint16_t Second;
  uint16_t MiniSecond;
} Hce_WiFi_Command_DateTime_Struct, *pHce_WiFi_Command_DateTime_Struct;

//4. Delete file
typedef struct _Hce_WiFi_Command_Execute_DeleteObject_ReqParaStruct_  {
  char DataPathString[HCE_WIFI_CAMERA_DATAPATH_STRLEN];
} Hce_WiFi_Command_Execute_DeleteObject_ReqParaStruct, *pHce_WiFi_Command_Execute_DeleteObject_ReqParaStruct;


typedef struct _MsgGroupFileInfoStruct_  {
   uint32_t ulGroupIndex;
   uint32_t ulGroupTotalEntry;
   HceWiFiDatabaseFileType eFileType;
   uint8_t pubFileFullPath[HCE_WIFI_FILE_FULL_PATH_MAX_LEN];  
}MsgGroupFileInfoStruct;

typedef struct _Hce_WiFi_MsgID_Get_Group_Info_ReqParaStruct_  {
  uint32_t                 ulStartIndex;
  uint32_t                 ulTotalNumber;
  HceWiFiGroupInfoFileType eGroupType;
}Hce_WiFi_MsgID_Get_Group_Info_ReqParaStruct;

typedef struct _Hce_WiFi_MsgID_Get_Group_Info_ResParaStruct_  {
  uint32_t                 ulTotalMatchedNumber;
  uint32_t                 ulCurrentResponseNumber;
  MsgGroupFileInfoStruct   psGroupFileInfo[HCE_WIFI_PB_MSG_FILE_GROUP_INFO_MAX_NUM];
}Hce_WiFi_MsgID_Get_Group_Info_ResParaStruct;    

typedef struct _Hce_WiFi_Command_State_MediaInfo_ReqParaStruct_  {
  Hce_WiFi_DataBase_Retrieve_Method RetrieveMethod;
  uint32_t FileRootPath; /* 0:Nand, 1:sd */
  char     FilePathString[HCE_WIFI_CAMERA_DATAPATH_STRLEN];
} Hce_WiFi_Command_State_MediaInfo_ReqParaStruct, *pHce_WiFi_Command_State_MediaInfo_ReqParaStruct;

typedef struct _Hce_WiFi_Command_State_MediaInfo_ResParaStruct_  {
  Hce_WiFi_Command_DateTime_Struct   FileCreatedTimeStruct;
  Hce_WiFi_DataBase_Orientation_Type FileOrientation;
  uint64_t FileSize;
  uint32_t ResWidth;
  uint32_t ResHeight;
  uint32_t codec;
  uint32_t format;
  uint32_t FrameRate;
  uint32_t VoiceCodec;
  uint32_t Duration;
} Hce_WiFi_Command_State_MediaInfo_ResParaStruct, *pHce_WiFi_Command_State_MediaInfo_ResParaStruct;

typedef struct _HCE_WIFI_FILE_GET_REQUEST_ {
  uint8_t        fileClass;
  uint8_t        fileMediaType;
  uint32_t       ulFileOffset;
  uint32_t       reqired_data_size;
  uint32_t       FilePathRoot;
  char           fileFullPath[64];
} HCE_WIFI_FILE_GET_REQUEST, *PHCE_WIFI_FILE_GET_REQUEST;

typedef struct _HCE_WIFI_FILE_GET_RESPONSE_ {
  uint8_t*        pContentBuffer;
  uint32_t        pContentBufferSize;
  uint8_t         FileEndFlag;
  uint8_t         Exec_Result; // 0:normal 1:unkown error 2:no such file 3:Exeed file max size 
} HCE_WIFI_FILE_GET_RESPONSE, *PHCE_WIFI_FILE_GET_RESPONSE;

//------------------------------------------------------------------------------------------

//HCE_WIFI_MESID_CGI_PLAYCMD_GET_GROUP_ENTRY_INFROMATION -----------------------------------
typedef struct _MsgEntryInfoStruct_  {
   uint32_t          ulFileIndex;
   uint32_t          FilePathRoot;
   uint8_t           pubFileFullPath[HCE_WIFI_FILE_FULL_PATH_MAX_LEN];
}MsgEntryInfoStruct;

typedef struct _Hce_WiFi_MsgID_Get_Group_Entry_Info_ReqParaStruct_  {
  uint32_t           ulGroupIndex;
  uint32_t           ulTotalNumber;
  uint32_t           ulStartingIndex;
}Hce_WiFi_MsgID_Get_Group_Entry_Info_ReqParaStruct;

typedef struct _Hce_WiFi_MsgID_Get_Group_Entry_Info_ResParaStruct_  {
  uint32_t           ulTotalMatchedNumber;
  uint32_t           ulCurrentResponseNumber;
  MsgEntryInfoStruct psEntryinfo[HCE_WIFI_PB_MSG_FILE_GROUP_ENTRY_INFO_MAX_NUM];
}Hce_WiFi_MsgID_Get_Group_Entry_Info_ResParaStruct;
//---------------------------------------------------------------------------------------------------
//---------------------------------------------------------------------------------------------------
//---------------------------------------------------------------------------------------------------
//---------------------------------------------------------------------------------------------------


// HCE_WIFI_MSGID_APP_SCAN
typedef struct _HCE_DLNA_MSGID_APP_SCAN_RES_PARA_ {
  /*
  *
  *  [friendlyname1]\0[friendlyname2]\0[friendlyname3]\0....
  *
  */
  uint8_t servers[420]; 
  uint8_t idxs[20]; //max 20
  uint8_t number;
} HCE_DLNA_MSGID_APP_SCAN_RES_PARA, *PHCE_DLNA_MSGID_APP_SCAN_RES_PARA;

typedef struct _HCE_DLNA_MSGID_SELECT_SERVER_REQ_PARA_{
  char    serverName[21];
  uint8_t serverIdx;
} HCE_DLNA_MSGID_SELECT_SERVER_REQ_PARA, *PHCE_DLNA_MSGID_SELECT_SERVER_REQ_PARA;

// HCE_WIFI_MSGID_APP_GET_PSS_VALUE
typedef struct _HCE_DLNA_MSGID_APP_GET_PSS_VALUE_RES_PARA_ {
  char pss_check_value[128];
} HCE_DLNA_MSGID_APP_GET_PSS_VALUE_RES_PARA, *PHCE_DLNA_MSGID_APP_GET_PSS_VALUE_RES_PARA;

//Start send image

// HCE_WIFI_MSGID_SEND_IMAGE_START
//It must same as HCE_WIFI_MSGID_SEND_IMAGE_START_REQ_PARA
typedef struct _HCE_DLNA_MSGID_SEND_IMAGE_START_REQ_PARA_ {
  uint32_t         resize;
  uint32_t         FilePathRoot;
  uint8_t          content_full_path[64]; //I:/DCIM/100_PANA/P1000001.JPG
  uint8_t*         ContentBuffer;
  uint32_t         nBufferSize;
  uint32_t         nWidth;
  uint32_t         nHeight;
} HCE_DLNA_MSGID_SEND_IMAGE_START_REQ_PARA, *PHCE_DLNA_MSGID_SEND_IMAGE_START_REQ_PARA;

// HCE_WIFI_MSGID_SEND_IMAGE_INFORMATION
typedef struct _Hce_WiFi_MsgID_App_Send_Image_Information_ReqParaType_ {
    uint32_t    uiTimeMs;
    uint32_t    uiSendSizeByte;
} Hce_WiFi_MsgID_App_Send_Image_Information_ReqParaType, *pHce_WiFi_MsgID_App_Send_Image_Information_ReqParaType;


//---------------------------------------------------------------------------
extern int   HceDLNA_GeneralMessageToWiFi(Hce_WiFi_MsgID_Type eMssageID,void* pvReqPtr,unsigned int ulReqLen,void* pvResPtr,unsigned int ulResLen);
extern int   HceDLNA_Remote_SendMsg(DLNASendMessageStruct *psRequeestStruct,DLNAResponseMessageStruct *psResponseStruct);
extern int   HceDLNA_IPC_DeInit(void);
extern int   HceDLNA_IPC_Init(void);

#endif
